<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| Fast-Sales Pro                                                              |
| Copyright (c) 2007-2013 Fsales development group <support@fast-sales.ru>    |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://fast-sales.ru/fsales_pro_license.html          |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  Fsales     |
| development group (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  |
| OR MAKING AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE       |
| "SOFTWARE"). PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS       |
| LICENSE AGREEMENT CAREFULLY   BEFORE   INSTALLING   OR  USING  THE          |
| SOFTWARE.  BY INSTALLING, COPYING   OR   OTHERWISE   USING   THE            |
| SOFTWARE,  YOU  AND  YOUR  COMPANY (COLLECTIVELY,  "YOU")  ARE  ACCEPTING   |
| AND AGREEING  TO  THE TERMS OF THIS LICENSE   AGREEMENT.   IF  YOU    ARE   |
| NOT  WILLING   TO  BE  BOUND BY THIS AGREEMENT, DO  NOT INSTALL OR USE THE  |
| SOFTWARE.  VARIOUS   COPYRIGHTS   AND OTHER   INTELLECTUAL   PROPERTY       |
| RIGHTS    PROTECT   THE   SOFTWARE.  THIS AGREEMENT IS A LICENSE AGREEMENT  |
| THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE THE  SOFTWARE   AND  NOT  AN     |
| AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS|
| NOT EXPRESSLY GRANTED BY THIS AGREEMENT.                                    |
|                                                                             |
| The Initial Developers of the Original Code are Fsales development group    |
| Portions created by Fsales development group are Copyright (C) 2007-2013    |
| Fsales development group. All Rights Reserved.                              |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

	error_reporting(0);

	session_start();

	header('Content-Type: text/html; charset=utf-8');
	
	@ini_set('memory_limit',             '32M');
	@ini_set('max_execution_time',       '0');
	@ini_set('session.use_only_cookies', '1');
	@ini_set('session.use_cookies',      '1');
	@ini_set('session.use_trans_sid',    '0');
	@ini_set('display_errors',           '1');
	@ini_set('magic_quotes_runtime',     '0');
	@ini_set('magic_quotes_sybase',      '0');
	
	function func_check_apache() {
		return preg_match('!apache!is', $_SERVER['SERVER_SOFTWARE']) > 0;
	}
	
	function func_check_mod_rewrite() {
		$pinfo = pathinfo($_SERVER['PHP_SELF']);
		
		$dirname = trim($pinfo['dirname'], '/\\');
		$uri     = str_replace('\\', '/', $dirname);
		
		if (empty($uri)) {
			$uri = '/';
		} else {
			$uri = '/'.$uri.'/';
		}
		
		$fpath = 'http://'.$_SERVER['SERVER_NAME'].$uri.'rew/test.html';
		
		return file_get_contents($fpath) == 'OK';
	}
	
	function func_check_php_version() {
		if (function_exists('phpversion') && function_exists('version_compare')) {
			return version_compare(phpversion(), '5.0') >= 0;
		}
		return false;
	}

	function func_check_mysql_supported() {
		return function_exists('mysql_connect') || function_exists('mysqli_connect');
	}
	
	function func_check_session_enabled() {
		if (session_id()) {
			return true;
		}

		return false;
	}
	
	function func_check_curl_supported() {
		return function_exists('curl_init');
	}
	
	function func_check_gd2_supported() {
		$return = true;
		
		$gd2_funcs = Array(
			'getimagesize',
			'imagecreatefromgif',
			'imagecreatefromjpeg',
			'imagecreatefrompng',
			'imagecreatetruecolor',
			'imagefill',
			'imagecopyresampled',
			'imagejpeg',
			'imagedestroy'
		);
		
		foreach ($gd2_funcs as $gd2_func) {
			if (!function_exists($gd2_func)) {
				$return = false;
				break;
			}
		}
		
		return $return;
	}
	
	function func_check_mbstring_supported() {
		return function_exists('mb_strtolower');
	}
	
	function func_check_zlib_supported() {
		return function_exists('gzopen');
	}
	
	function func_check_xml_supported() {
		return function_exists('xml_parser_create');
	}
	
	function func_check_tokenizer_supported() {
		return function_exists('token_get_all');
	}
	
	function func_check_iconv_supported() {
		return function_exists('iconv');
	}
	
	function func_check_safe_mode() {
		return ini_get('safe_mode') == 0;
	}
	
	function func_check_magic_quotes_runtime() {
		return ini_get('magic_quotes_runtime') == 0;
	}
	
	function func_check_magic_quotes_sybase() {
		return ini_get('magic_quotes_sybase') == 0;
	}
	
	function func_check_session_use_cookies() {
		return ini_get('session.use_cookies') == 1;
	}
	
	function func_check_memory_limit() {
		$val  = trim(ini_get('memory_limit'));
		$last = strtolower($val{strlen($val)-1});
		
		switch ($last) {
		case 'g':
			$val *= 1024;
		case 'm':
			$val *= 1024;
		case 'k':
			$val *= 1024;
		}
		
		if (!empty($val) && $val > 0 && $val < 16777216) {
			return false;
		}
		
		return true;
	}
	
	$requirement_msgs = array();
	
	if (!func_check_apache()) {
		$requirement_msgs[] = 'На сервере не установлен Apache, либо изменено значение переменной SERVER_SOFTWARE';
	}
	
	if (!func_check_mod_rewrite()) {
		if (is_dir('rew')) {
			$requirement_msgs[] = 'Модуль Apache mod_rewrite отсутствует, либо запрещена php-функция file_get_contents';
		} else {
			$requirement_msgs[] = 'Вы не скопировали папку <b>rew</b> из ZIP-архива скрипта тестирования';
		}
	}
	
	if (!func_check_php_version()) {
		$requirement_msgs[] = 'Fast-Sales не поддерживает версию PHP ниже 5.0';
	}
	
	if (!func_check_mysql_supported()) {
		$requirement_msgs[] = 'Необходимо включить поддержку MySQL на сервере';
	}

	if (!func_check_session_enabled()) {
		$requirement_msgs[] = 'Не работает механизм сессий PHP. Возможно, PHP-директива session.save_path указывает на несуществующую директорию';
	}
	
	if (!func_check_curl_supported()) {
		$requirement_msgs[] = 'Необходимо включить поддержку PHP-расширения CURL';
	}
	
	if (!func_check_gd2_supported()) {
		$requirement_msgs[] = 'Необходимо включить поддержку библиотеки GD. Версия данной библиотеки должны быть не ниже 2.0';
	}
	
	if (!func_check_mbstring_supported()) {
		$requirement_msgs[] = 'Необходимо включить поддержку PHP-расширения Multibyte String';
	}
	
	if (!func_check_zlib_supported()) {
		$requirement_msgs[] = 'Необходимо включить поддержку PHP-расширения ZLib';
	}
	
	if (!func_check_xml_supported()) {
		$requirement_msgs[] = 'Необходимо включить поддержку PHP-расширения XML';
	}
	
	if (!func_check_tokenizer_supported()) {
		$requirement_msgs[] = 'Необходимо включить поддержку PHP-расширения Tokenizer';
	}
	
	if (!func_check_iconv_supported()) {
		$requirement_msgs[] = 'Необходимо включить функцию iconv';
	}
	
	if (!func_check_safe_mode()) {
		$requirement_msgs[] = 'Директива safe_mode в php.ini должна быть установлена в значение "Off"';
	}
	
	if (!func_check_magic_quotes_runtime()) {
		$requirement_msgs[] = 'Директива magic_quotes_runtime в php.ini должна быть установлена в значение "Off"';
	}
	
	if (!func_check_magic_quotes_sybase()) {
		$requirement_msgs[] = 'Директива magic_quotes_sybase в php.ini должна быть установлена в значение "Off"';
	}
	
	if (!func_check_session_use_cookies()) {
		$requirement_msgs[] = 'Директива session.use_cookies в php.ini должна быть установлена в значение "On"';
	}
	
	if (!func_check_memory_limit()) {
		$requirement_msgs[] = 'Директива memory_limit в php.ini должна быть установлена в значение не менее 16M';
	}
	
	if (count($requirement_msgs) > 0) {
		echo '<center>';
		echo '<font color="red"><b>';
		echo 'Внимание! Обнаружены несовместимые с Fast-Sales настройки вашего сервера. Ниже даны рекомендации к их исправлению:';
		echo '<ul>';
		foreach ($requirement_msgs as $requirement_msg) {
			echo '<li>'.$requirement_msg.'</li>';
		}
		echo '</ul>';
		echo '</b></font>';
		echo '</center>';
	} else {
		echo '<center><font color="green"><b>Данный сервер совместим с CMS Fast-Sales</b></font></center>';
	}
	
	unset($requirement_msgs);
